// $Id: test.cc,v 1.3 2000/11/14 21:07:33 classic Exp $
//
// (c) by Torben Nehmer 2000
// torben@nehmer.net

#include "mailbox.h"
#include "iostream.h"

main () {
  Mailbox::mbx_status * pStatus;
  Mailbox::msg_header * pHeader;
  vector<long>::iterator iter;
  vector<long> vResult;
  Mailbox test ("servername", "username", "password");

  pStatus = test.select("inbox");

  cout << "####\n####\n";
  cout << pStatus->iExists << " Messages in Mailbox.\n";
  cout << pStatus->iRecent << " Messages recent.\n";
  cout << "First unread message is " << pStatus->iUnseen << ".\n";
  cout << "UID validity value: " << pStatus->iUIDValidity << endl;
  cout << "Predicted next UID: " << pStatus->iUIDNext << endl;
  cout << "Flags: ";
  copy (pStatus->vFlags.begin(),
	pStatus->vFlags.end(),
	ostream_iterator<string>(cout, " "));
  cout << endl;
  cout << "Permanent Flags: ";
  copy (pStatus->vPermflags.begin(),
	pStatus->vPermflags.end(),
	ostream_iterator<string>(cout, " "));
  cout << endl;

  vResult = test.search_unseen();
  cout << "Got " << vResult.size() << " hits\n";
  copy(vResult.begin(), vResult.end(), ostream_iterator<long>(cout, ", "));
  cout << endl;

  iter = vResult.begin();
  while (iter != vResult.end()) {
    cout << "Retrieving " << *iter << "...\n";
    pHeader = test.getheader(*iter);
    cout << "########### Message ID: " << *iter << endl;
    if (pHeader) {
      cout << "FROM:\t" << pHeader->strFrom << endl;
      cout << "TO:\t" << pHeader->strTo << endl;
      cout << "DATE:\t" << pHeader->strDate << endl;
      cout << "SUBJECT:" << pHeader->strSubject << endl;
      cout << "############\n";
      delete pHeader;
      pHeader = NULL;
    }
    iter++;
  }
  

  delete pStatus;
}
