// $Id: unread.cc,v 1.2 2000/11/14 23:52:14 classic Exp $
// 
// This is a simple shell client that checks an IMAP server for unseen
// Mails. It will show the message header for each unseen message.
// This version for the DMU assignment connects to mail.cse.dmu.ac.uk
// by default and therefore has the servername as last, optional
// argument on the command line.
// 
// Usage:
// unread [user [password [mailserver]]]
//
// It will ask any missing information upon launch.
//
// It uses the Mailbox class to access the remote Mailbox.
//
// (c) by Torben Nehmer 2000
// torben@nehmer.net

#include <stdlib.h>
#include "mailbox.h"
#include <vector>
#include <string>

int main (int argc, char** argv)
{
  string strServer = "nathan.nehmer.net";
  string strUser = "";
  string strPassword = "";
  
  switch (argc) {
  case 4: strServer = string(argv[3]);
  case 3: strPassword = string(argv[2]);
  case 2: strUser = string(argv[1]);
  }

#ifdef DEBUG
  cout << "DEBUG: Read from command line: \n";
  cout << "DEBUG: argc = " << argc << endl;
  cout << "DEBUG: strServer = \"" << strServer << "\"\n";
  cout << "DEBUG: strUser = \"" << strUser << "\"\n";
  cout << "DEBUG: strPassword = \"" << strPassword << "\"\n";
#endif

  if (strUser == "") {
    cout << "Please enter your Username : ";
    cin >> strUser;
  }

  if (strPassword == "") {
    cout << "Please enter your Password : ";
    cin >> strPassword;
  }

#ifdef DEBUG
  cout << "DEBUG: strServer = \"" << strServer << "\"\n";
  cout << "DEBUG: strUser = \"" << strUser << "\"\n";
  cout << "DEBUG: strPassword = \"" << strPassword << "\"\n";
#endif

  // Connecting to IMAP Mailserver
  Mailbox mbx(strServer, strUser, strPassword);
  Mailbox::mbx_status * mbx_status;
  Mailbox::msg_header * msg_header;
  vector<long> result;
  vector<long>::iterator iter;
  string input;

  if (mbx.get_iState() == 0) {
    cout << "Username or password is invalid.\n";
    exit(2);
  }

  mbx_status = mbx.select("inbox");
  if (mbx_status->iUnseen == -1) {
    cout << "No unread mail on server.\n";
    exit(1);
  }
  
  result = mbx.search_unseen();
  cout << mbx_status->iRecent << " recent messages.\n";
  cout << result.size() << " unread messages.\n";

  cout << "Do you want to display the message headers?\n"
       << "This will set the messages' seen flag! (y/[n])";
  cin >> input;
  if ( input.size() > 0 && (input[0] == 'y' || input[0] == 'Y') ) {
    iter = result.begin();
    while (iter != result.end()) {
      msg_header = mbx.getheader(*iter);
      cout << "============================================================\n";
      cout << "FROM    : " << msg_header->strFrom << endl;
      cout << "TO      : " << msg_header->strTo << endl;
      cout << "DATE    : " << msg_header->strDate << endl;
      cout << "SUBJECT : " << msg_header->strSubject << endl;
      delete msg_header;
      iter++;
    }
  }
  
  return 0;
}
